#[doc = "Register `MSK3` reader"]
pub struct R(crate::R<MSK3_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<MSK3_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::convert::From<crate::R<MSK3_SPEC>> for R {
    fn from(reader: crate::R<MSK3_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `MSK3` writer"]
pub struct W(crate::W<MSK3_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<MSK3_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl core::convert::From<crate::W<MSK3_SPEC>> for W {
    fn from(writer: crate::W<MSK3_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `MSK` reader - Interrupt Mask Register"]
pub struct MSK_R(crate::FieldReader<u8, u8>);
impl MSK_R {
    pub(crate) fn new(bits: u8) -> Self {
        MSK_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for MSK_R {
    type Target = crate::FieldReader<u8, u8>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `MSK` writer - Interrupt Mask Register"]
pub struct MSK_W<'a> {
    w: &'a mut W,
}
impl<'a> MSK_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x7f) | (value as u8 & 0x7f);
        self.w
    }
}
impl R {
    #[doc = "Bits 0:6 - Interrupt Mask Register"]
    #[inline(always)]
    pub fn msk(&self) -> MSK_R {
        MSK_R::new((self.bits & 0x7f) as u8)
    }
}
impl W {
    #[doc = "Bits 0:6 - Interrupt Mask Register"]
    #[inline(always)]
    pub fn msk(&mut self) -> MSK_W {
        MSK_W { w: self }
    }
    #[doc = "Writes raw bits to the register."]
    pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "Interrupt Mask\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [msk3](index.html) module"]
pub struct MSK3_SPEC;
impl crate::RegisterSpec for MSK3_SPEC {
    type Ux = u8;
}
#[doc = "`read()` method returns [msk3::R](R) reader structure"]
impl crate::Readable for MSK3_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [msk3::W](W) writer structure"]
impl crate::Writable for MSK3_SPEC {
    type Writer = W;
}
#[doc = "`reset()` method sets MSK3 to value 0"]
impl crate::Resettable for MSK3_SPEC {
    #[inline(always)]
    fn reset_value() -> Self::Ux {
        0
    }
}
